clear all
close all
clc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Universal Automatic Elbow Detection                                %%%%
%%% Eduardo Morgado Luca Martino, Roberto San Millán,                  %%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%
%%% JUST RUN ME !!
%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%
example=3;
disp('----------------------------------------------------')
%%%%%%%%%%%%%%%%%%%%
switch example
    case 1    
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Clustering
       load Clustering_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       disp('Clustering Experiment')
     case 2    
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Polynomial fitting
       load Pol_Fitting_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       disp('Polynomial fitting Experiment')
     case 3  
          %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%%  AR model just one run in the Monte Carlo simuation
       load ARmodel_JustOneRunExample_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       disp('AR model just one run in the Monte Carlo simuation')
       disp(' with true order 5, std of noise 1, number of data T=2000' )
     case 4
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Variable Selection regression Soundscape Data
       load VarSelection_regresion_SoundscapeData_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       disp('Variable Selection regression Soundscape Data - Experiment')
     case 5
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Variable Selection classification Biomedical Data
       load VarSelection_classification_BioData_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
       disp('Variable Selection classification Biomedical Data - Experiment 1')
      case 6
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Variable Selection classification Biomedical Data
       load VarSelection_classification_BioData_experiment2
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
       disp('Variable Selection classification Biomedical Data - Experiment 2')      
     case 7
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       %%% Artificial example
        components=0:1:50;
        V=exp(-0.1*components.^2);
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       disp(['Artificial Example ',num2str(example)])
     case 8
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       %%% Artificial example
        components=0:1:50;
        V=exp(-0.01*components.^2);
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
        disp(['Artificial Example ',num2str(example)])
    otherwise
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       %%% Artificial example
        components=0:1:50;
        V=exp(-0.001*components.^2);
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       disp('Artificial Example - other')
end
disp('----------------------------------------------------')
%%%%%%%%%%%%%%%%%
V=V-min(V); %%% just a check, without loss of generality
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
kmax=length(V)-1;
lambda=V(1)/kmax;
CostFun=V+lambda*[0:kmax];
pos=find(CostFun==min(CostFun));
Elbow=pos-1;
disp('------------------------------------------------------------------')
disp('Position of the Elbow - number of components chosen:')
Elbow
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if example==1
    disp('in the clustering case, k=0 represents one cluster...then, the solutions are:')
    disp(Elbow+1)
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
plot(0:kmax,V,'LineWidth',2)
hold on
plot(Elbow,V(pos),'ro','MarkerSize',10,'MarkerFaceColor','g')
set(gca,'Fontsize',20)
xlabel('k')
ylabel('V(k)')
legend('V(k)','Elbow')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

